<?php
// prevent XSS
if (isset($_REQUEST['_SESSION'])) exit();

session_start();
require_once($_SESSION['PM_INCPHP'] . "/globals.php");
require_once($_SESSION['PM_INCPHP'] . "/common.php");
require_once("projection.php");

$clickX = $_REQUEST['x'];
$clickY = $_REQUEST['y'];

$fromPrj = $map->getProjection();

if (!isset($_SESSION['pluginsConfig']['coordinates'])) {
    pm_logDebug(0, "P.MAPPER-ERROR: Configuration under '<pluginsConfig><coordinates>' is missing. Check your config.xml file.");
    return false;
}

$prjCfg = $_SESSION['pluginsConfig']['coordinates'];
$mapPrj = $prjCfg['mapPrj'];
$mapPrjName = _p($mapPrj['name']);

$showX = round($clickX, $mapPrj['roundTo']);
$showY = round($clickY, $mapPrj['roundTo']);

$prjJson = "[";
$prjJson .= "{\"prjName\": \"$mapPrjName\", \"x\": $showX, \"y\": $showY},";

$prjList = $prjCfg['prj'];
foreach ($prjList as $p) {
    $prjName = _p($p['name']);
    $roundTo = $p['roundTo'];
    $toPrj = $p['definition'];
    $prj = new Projection($clickX, $clickY, $fromPrj, $toPrj);
    $x = $prj->getX();
    $y = $prj->getY();
    
    //round values
    $x = round($x, $roundTo);
    $y = round($y, $roundTo);
    
    $prjJson .= "{\"prjName\": \"$prjName\", \"x\": $x, \"y\": $y},";
}
$prjJson = substr($prjJson, 0, -1) . "]";


header("Content-Type: text/plain; charset=$defCharset");

// return JS object literals "{}" for XMLHTTP request 
echo "{\"prjJson\": $prjJson}";
?>